'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createElement = require('@f/create-element');

var _createElement2 = _interopRequireDefault(_createElement);

var _setAttribute = require('./setAttribute');

var _setAttribute2 = _interopRequireDefault(_setAttribute);

var _foreach = require('@f/foreach');

var _foreach2 = _interopRequireDefault(_foreach);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Create a DOM element
 */

function createNode(vnode, children, element) {
  var type = vnode.type;
  var node = void 0;

  if (!element) {
    if (type === '#text') {
      vnode.element = document.createTextNode(vnode.props.nodeValue);
      return vnode;
    }

    node = vnode.element = (0, _createElement2.default)(type);
  } else {
    node = vnode.element = element;
  }

  (0, _foreach2.default)(function (child) {
    return node.appendChild(child.element);
  }, children);
  (0, _foreach2.default)(function (value, name) {
    return (0, _setAttribute2.default)(node, name, value);
  }, vnode.props);
  return vnode;
}

/**
 * Exports
 */

/**
 * Imports
 */

exports.default = createNode;