'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _replaceElement = require('@f/replace-element');

var _replaceElement2 = _interopRequireDefault(_replaceElement);

var _insertElement = require('@f/insert-element');

var _insertElement2 = _interopRequireDefault(_insertElement);

var _removeElement = require('@f/remove-element');

var _removeElement2 = _interopRequireDefault(_removeElement);

var _updateNode = require('./updateNode');

var _updateNode2 = _interopRequireDefault(_updateNode);

var _createNode = require('./createNode');

var _createNode2 = _interopRequireDefault(_createNode);

var _foreach = require('@f/foreach');

var _foreach2 = _interopRequireDefault(_foreach);

var _virtex = require('virtex');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Constants
 */

var _actions$types = _virtex.actions.types; /**
                                             * Imports
                                             */

var CREATE_NODE = _actions$types.CREATE_NODE;
var UPDATE_NODE = _actions$types.UPDATE_NODE;
var REMOVE_NODE = _actions$types.REMOVE_NODE;
var REPLACE_NODE = _actions$types.REPLACE_NODE;
var INSERT_NODE = _actions$types.INSERT_NODE;

/**
 * Virtex DOM effects driver
 */

function dom() {
  return function (next) {
    return function (action) {
      switch (action.type) {
        case CREATE_NODE:
          return (0, _createNode2.default)(action.vnode, action.children, action.element);
        case UPDATE_NODE:
          return (0, _updateNode2.default)(action.prev, action.vnode);
        case REMOVE_NODE:
          (0, _removeElement2.default)(action.vnode.element);
          return action.vnode;
        case REPLACE_NODE:
          (0, _replaceElement2.default)(action.vnode.element, action.prev.element);
          return action.vnode;
        case INSERT_NODE:
          (0, _insertElement2.default)(action.vnode.element, action.newVnode.element, action.pos);
          return action.vnode;
      }

      return next(action);
    };
  };
}

/**
 * Exports
 */

exports.default = dom;